diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
index b0b2405af..e33df5c6a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerBase.java
@@ -2,20 +2,24 @@ package net.minecraft.core.world.save;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.MinecraftException;
-import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkLoaderLegacy;
 import net.minecraft.core.world.chunk.IChunkLoader;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.File;
+import java.io.FileOutputStream;
 import java.io.IOException;
 import java.nio.file.Files;
 import java.util.List;
+import java.util.UUID;
 
 public abstract class SaveHandlerBase implements LevelStorage
 {
@@ -27,7 +31,7 @@ public abstract class SaveHandlerBase implements LevelStorage
 	protected final long now = System.currentTimeMillis();
 	protected final ISaveFormat saveFormat;
 
-	public SaveHandlerBase(ISaveFormat saveFormat, File savesDir, String worldDirName, boolean isMultiplayer)
+	public SaveHandlerBase(ISaveFormat saveFormat, File savesDir, String worldDirName)
 	{
 		this.worldDirName = worldDirName;
 		this.saveFormat = saveFormat;
@@ -36,10 +40,7 @@ public abstract class SaveHandlerBase implements LevelStorage
 		playersDirectory = new File(saveDirectory, "players");
 		dataDirectory = new File(saveDirectory, "data");
 		dataDirectory.mkdirs();
-		if (isMultiplayer)
-		{
-			playersDirectory.mkdirs();
-		}
+		playersDirectory.mkdirs();
 		lockSession();
 	}
 
@@ -116,9 +117,9 @@ public abstract class SaveHandlerBase implements LevelStorage
 	}
 
 	@Override
-	public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
+	public void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList)
 	{
-		CompoundTag dataTag = levelData.getNBTTagCompoundWithPlayer(playerList);
+		CompoundTag dataTag = levelData.getNBTTagCompound();
 		CompoundTag savedTag = new CompoundTag();
 		savedTag.put("Data", dataTag);
 		try
@@ -146,6 +147,14 @@ public abstract class SaveHandlerBase implements LevelStorage
 		{
 			LOGGER.error("Failed to save level data to disk!", exception);
 		}
+
+		for (Player player : playerList) {
+			try {
+				save(player);
+			} catch (Exception e) {
+				LOGGER.error("Failed to save player data for player '{}'!", player.username, e);
+			}
+		}
 	}
 
 	@Override
@@ -237,10 +246,79 @@ public abstract class SaveHandlerBase implements LevelStorage
 		return new File(dataDirectory, fileName + ".dat");
 	}
 
+	@Override
+	public void save(@NotNull Player player)
+	{
+		try
+		{
+			CompoundTag compoundTag = new CompoundTag();
+			player.saveWithoutId(compoundTag);
+			compoundTag.putInt("Format", 1);
+			File temp = new File(playersDirectory, "_tmp_.dat");
+			File save = new File(playersDirectory, player.uuid + ".dat");
+			NbtIo.writeCompressed(compoundTag, new FileOutputStream(temp));
+			if(save.exists())
+			{
+				save.delete();
+			}
+			temp.renameTo(save);
+		}
+		catch(Exception exception)
+		{
+			LOGGER.warn("Failed to save player data for " + player.username);
+		}
+	}
+
+	@Override
+	public void load(@NotNull Player player)
+	{
+		CompoundTag tag = getPlayerData(player.username, player.uuid);
+		if(tag != null)
+		{
+			player.load(tag);
+			return;
+		}
+		LevelData data;
+		if ((data = getLevelData()) != null){
+			tag = data.getPlayerNBTTagCompound();
+			if (tag != null) {
+				player.load(tag);
+			}
+		}
+	}
+
 	@Override
 	public PlayerIO getPlayerFileData()
 	{
+		return this;
+	}
+
+	public @Nullable CompoundTag getPlayerData(@Nullable String username, @NotNull UUID uuid)
+	{
+		try
+		{
+			File uuidFile = new File(playersDirectory, uuid + ".dat");
+			if(uuidFile.exists())
+			{
+				return NbtIo.readCompressed(Files.newInputStream(uuidFile.toPath()));
+			} else if (username != null) { // If the uuid file doesn't exist attempt to load the old username file
+				File nameFile = new File(playersDirectory, username + ".dat");
+				if (nameFile.exists()) {
+					CompoundTag tag = NbtIo.readCompressed(Files.newInputStream(nameFile.toPath()));
+					nameFile.renameTo(uuidFile);
+					return tag;
+				}
+			}
+		}
+		catch(Exception exception)
+		{
+            LOGGER.warn("Failed to load player data for {}", username);
+		}
 		return null;
 	}
 
+	@FunctionalInterface
+	public static interface SaveHandlerFactory {
+		@NotNull SaveHandlerBase apply(ISaveFormat saveFormat, File savesDir, String worldDirName);
+	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerCore.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerCore.java
index 6e3300bd7..bb4f31318 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerCore.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerCore.java
@@ -4,6 +4,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkLoaderRegionAsync;
 import net.minecraft.core.world.chunk.IChunkLoader;
+import org.jetbrains.annotations.NotNull;
 
 import java.io.File;
 import java.util.List;
@@ -12,9 +13,9 @@ public class SaveHandlerCore
         extends SaveHandlerBase
 {
 
-    public SaveHandlerCore(ISaveFormat saveFormat, File savesDir, String worldDirName, boolean isMultiplayer)
+    public SaveHandlerCore(ISaveFormat saveFormat, File savesDir, String worldDirName)
     {
-        super(saveFormat, savesDir, worldDirName, isMultiplayer);
+        super(saveFormat, savesDir, worldDirName);
     }
     
     @Override
@@ -27,7 +28,7 @@ public class SaveHandlerCore
     }
 
     @Override
-    public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
+    public void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList)
     {
         levelData.setSaveVersion(saveFormat.getSaveVersion());
         super.saveLevelDataAndPlayerData(levelData, playerList);
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
index 4fab0e346..eb2f09484 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveHandlerServer.java
@@ -4,17 +4,14 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.chunk.IChunkLoader;
-import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkLoaderRegion;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 
 import java.io.File;
-import java.io.FileOutputStream;
-import java.nio.file.Files;
 import java.util.List;
-import java.util.UUID;
 
 
 public class SaveHandlerServer
@@ -25,7 +22,7 @@ public class SaveHandlerServer
 
     public SaveHandlerServer(ISaveFormat saveFormat, File savesDir, String worldDirName, boolean isMultiplayer)
     {
-        super(saveFormat, savesDir, worldDirName, isMultiplayer);
+        super(saveFormat, savesDir, worldDirName);
     }
     
     @Override
@@ -38,72 +35,20 @@ public class SaveHandlerServer
     }
 
     @Override
-    public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
+    public void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList)
     {
         levelData.setSaveVersion(saveFormat.getSaveVersion());
         super.saveLevelDataAndPlayerData(levelData, playerList);
     }
 
     @Override
-    public void save(Player player)
+    public void load(@NotNull Player player)
     {
-        try
+        CompoundTag tag = getPlayerData(player.username, player.uuid);
+        if(tag != null)
         {
-            CompoundTag nbttagcompound = new CompoundTag();
-            player.saveWithoutId(nbttagcompound);
-            nbttagcompound.putInt("Format", 1);
-            File temp = new File(playersDirectory, "_tmp_.dat");
-            File save = new File(playersDirectory, player.uuid + ".dat");
-            NbtIo.writeCompressed(nbttagcompound, new FileOutputStream(temp));
-            if(save.exists())
-            {
-                save.delete();
-            }
-            temp.renameTo(save);
+            player.load(tag);
         }
-        catch(Exception exception)
-        {
-            LOGGER.warn("Failed to save player data for " + player.username);
-        }
-    }
-
-    @Override
-    public void load(Player player)
-    {
-        CompoundTag nbttagcompound = getPlayerData(player.username, player.uuid);
-        if(nbttagcompound != null)
-        {
-            player.load(nbttagcompound);
-        }
-    }
-
-    @Override
-    public PlayerIO getPlayerFileData()
-    {
-        return this;
     }
 
-    private CompoundTag getPlayerData(String username, UUID uuid)
-    {
-        try
-        {
-            File uuidFile = new File(playersDirectory, uuid + ".dat");
-            if(uuidFile.exists())
-            {
-                return NbtIo.readCompressed(Files.newInputStream(uuidFile.toPath()));
-            } else { // If the uuid file doesn't exist attempt to load the old username file
-                File nameFile = new File(playersDirectory, username + ".dat");
-                if (nameFile.exists()) {
-                    CompoundTag tag = NbtIo.readCompressed(Files.newInputStream(nameFile.toPath()));
-                    nameFile.renameTo(uuidFile);
-                    return tag;
-                }
-            }
-        }
-        catch(Exception exception)
-        {
-            LOGGER.warn("Failed to load player data for " + username);
-        }
-        return null;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
new file mode 100644
index 000000000..cd6b5ea3d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
@@ -0,0 +1,115 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.save.ISaveFormat;
+import net.minecraft.core.world.type.WorldTypeGroups;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class WorldConfiguration {
+    private @NotNull String worldName = "";
+    private long numericSeed = new Random().nextLong();
+    private @NotNull String stringSeed = "";
+    private boolean cheatsEnabled = false;
+    private @NotNull Gamemode gamemode = Gamemode.survival;
+    private @NotNull WorldTypeGroups.Group worldTypeGroup = WorldTypeGroups.DEFAULT;
+
+    public WorldConfiguration() {
+    }
+
+    public @NotNull String getWorldName() {
+        return this.worldName;
+    }
+
+    public @NotNull String getFinalWorldName() {
+        if (MathHelper.stringNullOrLengthZero(this.worldName)) {
+            return I18n.getInstance().translateKey("gui.create_world.label.new_world");
+        }
+
+        return this.worldName;
+    }
+
+    public void setWorldName(final @NotNull String worldName) {
+        this.worldName = worldName;
+    }
+
+    public long getNumericSeed() {
+        return this.numericSeed;
+    }
+
+    public long getFinalNumericSeed() {
+        if (MathHelper.stringNullOrLengthZero(this.stringSeed)) {
+            return this.numericSeed;
+        } else {
+            try {
+                final long parsedSeed = Long.parseLong(this.stringSeed);
+                if (parsedSeed != 0L) {
+                    return parsedSeed;
+                }
+            } catch (final @NotNull NumberFormatException e) {
+                return this.stringSeed.hashCode();
+            }
+        }
+
+        return this.numericSeed;
+    }
+
+    public void regenNumericSeed() {
+        this.numericSeed = new Random().nextLong();
+    }
+
+    public @NotNull String getStringSeed() {
+        return this.stringSeed;
+    }
+
+    public void setStringSeed(final @NotNull String seed) {
+        this.stringSeed = seed;
+    }
+
+    public boolean getCheatsEnabled() {
+        return this.cheatsEnabled;
+    }
+
+    public void setCheatsEnabled(final boolean cheatsEnabled) {
+        this.cheatsEnabled = cheatsEnabled;
+    }
+
+    public @NotNull Gamemode getGamemode() {
+        return this.gamemode;
+    }
+
+    public void setGamemode(final @NotNull Gamemode gamemode) {
+        this.gamemode = gamemode;
+    }
+
+    public @NotNull WorldTypeGroups.Group getWorldTypeGroup() {
+        return this.worldTypeGroup;
+    }
+
+    public void setWorldTypeGroup(final @NotNull WorldTypeGroups.Group worldTypeGroup) {
+        this.worldTypeGroup = worldTypeGroup;
+    }
+
+    public @NotNull String getFolderName(final @NotNull ISaveFormat saveFormat) {
+        final char @NotNull [] ac = ChatAllowedCharacters.ALLOWED_CHARACTERS_ARRAY;
+        @NotNull String folderName = this.worldName.trim();
+        if (MathHelper.stringNullOrLengthZero(folderName)) {
+            folderName = I18n.getInstance().translateKey("gui.create_world.label.new_world");
+        }
+
+        for (final char c : ac) {
+            folderName = folderName.replace(c, '_');
+        }
+
+        int count = 1;
+        for (; saveFormat.getLevelData(folderName) != null; count++) {
+            folderName = folderName + " (" + count + ")";
+        }
+        return folderName;
+    }
+}
diff --git a/game/core/src/main/resources/lang/en_US/subtitles.lang b/game/core/src/main/resources/lang/en_US/subtitles.lang
index ac0d5cdfd..665afe394 100644
--- a/game/core/src/main/resources/lang/en_US/subtitles.lang
+++ b/game/core/src/main/resources/lang/en_US/subtitles.lang
@@ -92,6 +92,7 @@ subtitles.tile.piston.in=Piston retracted
 
 subtitles.tile.tnt.fuse=TNT lit
 subtitles.tile.sensor_block.sense=Mob sensed
+subtitles.tile.mobspawner.spawn=Mob spawned
 
 subtitles.tile.dispenser.click=Dispenser click
 subtitles.tile.dispenser.eject=Dispenser eject
diff --git a/game/core/src/main/resources/lang/en_US/tile.lang b/game/core/src/main/resources/lang/en_US/tile.lang
index 0ae07fd2a..4e481d3c7 100644
--- a/game/core/src/main/resources/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/lang/en_US/tile.lang
@@ -25,6 +25,12 @@ tile.cobble.granite.name=Cobbled Granite
 tile.cobble.granite.desc=Granite, smashed apart and reconstituted.
 tile.cobble.permafrost.name=Cobbled Permafrost
 tile.cobble.permafrost.desc=Permafrost, smashed apart and reconstituted.
+tile.cobble.basalt.mossy.name=Mossy Cobbled Basalt
+tile.cobble.basalt.mossy.desc=Cobbled basalt with added greenery.
+tile.cobble.limestone.mossy.name=Mossy Cobbled Limestone
+tile.cobble.limestone.mossy.desc=Cobbled limestone with added greenery.
+tile.cobble.granite.mossy.name=Mossy Cobbled Granite
+tile.cobble.granite.mossy.desc=Cobbled granite with added greenery.
 
 tile.pillar.marble.name=Marble Pillar
 tile.pillar.marble.desc=A block of marble engraved into a pillar.
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
index 004235a1c..1726a51bf 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
@@ -196,7 +196,7 @@ public class PacketHandlerLogin extends PacketHandler
                 player.playerNetServerHandler.sendPacket(new PacketRecipeSync(recipe,Registries.RECIPES.getAllSerializableRecipes().size()));
             }
             player.playerNetServerHandler.sendPacket(new PacketSyncIDs(PacketSyncIDs.DESTINATION_SOUND_IDS, SoundTypes.getSoundIds()));
-            player.playerNetServerHandler.sendPacket(new PacketSyncIDs(PacketSyncIDs.DESTINATION_ENTITY_IDS, EntityDispatcher.getEntityIds()));
+            player.playerNetServerHandler.sendPacket(new PacketSyncIDs(PacketSyncIDs.DESTINATION_ENTITY_IDS, EntityDispatcher.getInstance().getEntityIds()));
 
             packetHandler.sendPacket(new PacketSetSpawnPosition(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z));
             mcServer.playerList.setTime(player, worldserver);
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index d5bdbf90f..5db443aa2 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -47,8 +47,6 @@ import org.slf4j.Logger;
 
 import java.nio.charset.StandardCharsets;
 import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.Map;
 
 public class PacketHandlerServer extends PacketHandler
         implements ICommandListener
@@ -104,8 +102,7 @@ public class PacketHandlerServer extends PacketHandler
             if (tileentity instanceof TileEntityMobSpawner)
             {
                 TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) tileentity;
-                NamespaceID namespaceID = EntityDispatcher.idForClass(packet.entityClass);
-                tileEntityMobSpawner.setMobId(namespaceID == null ? "none" : namespaceID.toString());
+                tileEntityMobSpawner.setMobId(packet.dispatcherEntry == null ? "none" : packet.dispatcherEntry.stringID);
 
                 tileEntityMobSpawner.setChanged();
                 world.markBlockNeedsUpdate(packet.xPosition, packet.yPosition, packet.zPosition);
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index a973d0220..dcea78b96 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -28,6 +28,7 @@ public class WorldServer extends World
         super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType);
         entityIntHashMap = new Int2ObjectOpenHashMap<>();
         mcServer = minecraftserver;
+        getLevelData().setLastPlayerUUID(null);
     }
 
     @Override
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
index 266f41298..dad2553b0 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
@@ -4,17 +4,17 @@ import net.minecraft.core.util.collection.NamespaceID;
 import org.useless.seedviewer.collections.ChunkLocation;
 import org.useless.seedviewer.collections.ChunkPos2D;
 import org.useless.seedviewer.collections.ChunkPos3D;
-import org.useless.seedviewer.data.Biome;
-import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.data.ViewerBiome;
+import org.useless.seedviewer.data.ViewerChunk;
 import org.useless.seedviewer.gui.ChunkProvider;
 
 public class TestChunkProvider implements ChunkProvider {
     @Override
-    public Chunk getChunk(ChunkLocation location) {
-        return new Chunk() {
+    public ViewerChunk getChunk(ChunkLocation location) {
+        return new ViewerChunk() {
             @Override
-            public Biome getBiome(ChunkPos3D pos) {
-                return new Biome() {
+            public ViewerBiome getBiome(ChunkPos3D pos) {
+                return new ViewerBiome() {
                     @Override
                     public String getName() {
                         return "Test Biome";
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
index e807a1b2a..a53b39378 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
@@ -4,9 +4,9 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
-import org.useless.seedviewer.data.Biome;
+import org.useless.seedviewer.data.ViewerBiome;
 
-public class BTABiome implements Biome {
+public class BTABiome implements ViewerBiome {
     private final net.minecraft.core.world.biome.Biome biome;
     public BTABiome(net.minecraft.core.world.biome.Biome biome) {
         this.biome = biome;
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
index c6f5cc2a5..f6996d8e8 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
@@ -13,7 +13,7 @@ import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.type.WorldTypes;
 import org.useless.seedviewer.bta.worldloader.ChunkLoader;
 import org.useless.seedviewer.collections.ChunkLocation;
-import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.data.ViewerChunk;
 import org.useless.seedviewer.gui.ChunkProvider;
 import org.slf4j.Logger;
 
@@ -48,7 +48,7 @@ public class BTAChunkProvider implements ChunkProvider {
         chunkLoader = new ChunkLoader(worldFolder, 0);
     }
     @Override
-    public Chunk getChunk(ChunkLocation location) {
+    public ViewerChunk getChunk(ChunkLocation location) {
         if (chunkLoader != null) {
             try {
                 net.minecraft.core.world.chunk.Chunk c = chunkLoader.loadChunk(location);
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
index e4fb3beb7..519993199 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
@@ -8,10 +8,10 @@ import net.minecraft.core.world.biome.provider.BiomeProvider;
 import org.jetbrains.annotations.NotNull;
 import org.useless.seedviewer.collections.ChunkPos2D;
 import org.useless.seedviewer.collections.ChunkPos3D;
-import org.useless.seedviewer.data.Biome;
-import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.data.ViewerBiome;
+import org.useless.seedviewer.data.ViewerChunk;
 
-public class BTAComplexChunk implements Chunk {
+public class BTAComplexChunk implements ViewerChunk {
     private final net.minecraft.core.world.chunk.Chunk chunk;
     private final BiomeProvider provider;
     public BTAComplexChunk(@NotNull net.minecraft.core.world.chunk.Chunk chunk, BiomeProvider biomeProvider) {
@@ -19,10 +19,10 @@ public class BTAComplexChunk implements Chunk {
         this.provider = biomeProvider;
     }
     @Override
-    public Biome getBiome(ChunkPos3D pos) {
+    public ViewerBiome getBiome(ChunkPos3D pos) {
         net.minecraft.core.world.biome.Biome b = chunk.getBlockBiome(pos.x, pos.y, pos.z);
         if (b != null) return new BTABiome(b);;
-        return new BTABiome(provider.getBiome(chunk.xPosition * Chunk.CHUNK_SIZE_X + pos.x, pos.y, chunk.zPosition * Chunk.CHUNK_SIZE_Z + pos.z));
+        return new BTABiome(provider.getBiome(chunk.xPosition * ViewerChunk.CHUNK_SIZE_X + pos.x, pos.y, chunk.zPosition * ViewerChunk.CHUNK_SIZE_Z + pos.z));
     }
 
     @Override
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java
index b25426067..1951905be 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java
@@ -4,10 +4,10 @@ import net.minecraft.core.world.biome.provider.BiomeProvider;
 import org.useless.seedviewer.collections.ChunkLocation;
 import org.useless.seedviewer.collections.ChunkPos2D;
 import org.useless.seedviewer.collections.ChunkPos3D;
-import org.useless.seedviewer.data.Biome;
-import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.data.ViewerBiome;
+import org.useless.seedviewer.data.ViewerChunk;
 
-public class BTASimpleChunk implements Chunk {
+public class BTASimpleChunk implements ViewerChunk {
     private final ChunkLocation location;
     private final BiomeProvider provider;
     public BTASimpleChunk(ChunkLocation location, BiomeProvider biomeProvider) {
@@ -15,8 +15,8 @@ public class BTASimpleChunk implements Chunk {
         provider = biomeProvider;
     }
     @Override
-    public Biome getBiome(ChunkPos3D pos) {
-        return new BTABiome(provider.getBiome(location.x * Chunk.CHUNK_SIZE_X + pos.x, pos.y, location.z * Chunk.CHUNK_SIZE_Z + pos.z));
+    public ViewerBiome getBiome(ChunkPos3D pos) {
+        return new BTABiome(provider.getBiome(location.x * ViewerChunk.CHUNK_SIZE_X + pos.x, pos.y, location.z * ViewerChunk.CHUNK_SIZE_Z + pos.z));
     }
 
     @Override
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
index 34329fad4..f404bcfed 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
@@ -3,13 +3,13 @@ package org.useless.seedviewer.bta;
 import net.minecraft.core.world.save.LevelData;
 import org.jetbrains.annotations.NotNull;
 import org.useless.seedviewer.bta.worldloader.LevelDataLoader;
-import org.useless.seedviewer.data.World;
+import org.useless.seedviewer.data.ViewerWorld;
 import org.useless.seedviewer.gui.ChunkProvider;
 
 import java.io.File;
 import java.util.Objects;
 
-public class BTAWorld implements World {
+public class BTAWorld implements ViewerWorld {
     private final @NotNull File worldFolder;
     private final LevelData data;
     public BTAWorld(@NotNull File worldFolder) {
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/collections/ChunkPos2D.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/collections/ChunkPos2D.java
index 13c13f016..1681a4c1c 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/collections/ChunkPos2D.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/collections/ChunkPos2D.java
@@ -1,6 +1,6 @@
 package org.useless.seedviewer.collections;
 
-import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.data.ViewerChunk;
 
 import java.util.Objects;
 
@@ -10,16 +10,16 @@ public class ChunkPos2D {
 
     public ChunkPos2D(int x, int z) {
         if (x < 0) {
-            throw new IllegalArgumentException("X must be between in range [0, " + Chunk.CHUNK_SIZE_X + "]!");
+            throw new IllegalArgumentException("X must be between in range [0, " + ViewerChunk.CHUNK_SIZE_X + "]!");
         }
-        if (x > Chunk.CHUNK_SIZE_X) {
-            throw new IllegalArgumentException("X must be between in range [0, " + Chunk.CHUNK_SIZE_X + "]!");
+        if (x > ViewerChunk.CHUNK_SIZE_X) {
+            throw new IllegalArgumentException("X must be between in range [0, " + ViewerChunk.CHUNK_SIZE_X + "]!");
         }
         if (z < 0) {
-            throw new IllegalArgumentException("Z must be between in range [0, " + Chunk.CHUNK_SIZE_Z + "]!");
+            throw new IllegalArgumentException("Z must be between in range [0, " + ViewerChunk.CHUNK_SIZE_Z + "]!");
         }
-        if (z > Chunk.CHUNK_SIZE_Z) {
-            throw new IllegalArgumentException("Z must be between in range [0, " + Chunk.CHUNK_SIZE_Z + "]!");
+        if (z > ViewerChunk.CHUNK_SIZE_Z) {
+            throw new IllegalArgumentException("Z must be between in range [0, " + ViewerChunk.CHUNK_SIZE_Z + "]!");
         }
         this.x = x;
         this.z = z;
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/collections/ChunkPos3D.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/collections/ChunkPos3D.java
index 48100c7ab..bac228140 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/collections/ChunkPos3D.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/collections/ChunkPos3D.java
@@ -1,6 +1,6 @@
 package org.useless.seedviewer.collections;
 
-import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.data.ViewerChunk;
 
 import java.util.Objects;
 
@@ -13,10 +13,10 @@ public final class ChunkPos3D extends ChunkPos2D {
     public ChunkPos3D(int x, int y, int z) {
         super(x, z);
         if (y < 0) {
-            throw new IllegalArgumentException("Y must be between in range [0, " + Chunk.CHUNK_SIZE_Y + "]!");
+            throw new IllegalArgumentException("Y must be between in range [0, " + ViewerChunk.CHUNK_SIZE_Y + "]!");
         }
-        if (y > Chunk.CHUNK_SIZE_Y) {
-            throw new IllegalArgumentException("Y must be between in range [0, " + Chunk.CHUNK_SIZE_Y + "]!");
+        if (y > ViewerChunk.CHUNK_SIZE_Y) {
+            throw new IllegalArgumentException("Y must be between in range [0, " + ViewerChunk.CHUNK_SIZE_Y + "]!");
         }
         this.y = y;
     }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/data/Biome.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerBiome.java
similarity index 84%
rename from util/seed-viewer/src/main/java/org/useless/seedviewer/data/Biome.java
rename to util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerBiome.java
index 5c4f56f7b..f58a827f7 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/data/Biome.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerBiome.java
@@ -2,7 +2,7 @@ package org.useless.seedviewer.data;
 
 import net.minecraft.core.util.collection.NamespaceID;
 
-public interface Biome {
+public interface ViewerBiome {
     String getName();
     NamespaceID getID();
     int getColor();
